SystemOrganization addCategory: #'PBE-LightsOut'!

SimpleSwitchMorph subclass: #LOCell
	instanceVariableNames: 'mouseAction lClick'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PBE-LightsOut'!

!LOCell methodsFor: 'as yet unclassified' stamp: 'alexz 9/22/2012 16:11'!
initialize 
	super initialize.
	self label: ''.
	self  borderWidth: 2.
	bounds := 0@0 corner: 32@32.
	offColor := Color paleYellow.
	onColor := Color paleGreen  darker.
	self turnOn ! !

!LOCell methodsFor: 'accessing' stamp: 'alexz 9/19/2012 21:24'!
mouseAction: aBlock
	^ mouseAction := aBlock! !

!LOCell methodsFor: 'as yet unclassified' stamp: 'DDC 9/21/2012 21:27'!
mouseDown: evt
lClick := evt redButtonPressed! !

!LOCell methodsFor: 'as yet unclassified' stamp: 'DDC 9/21/2012 21:27'!
mouseUp: anEvent
 mouseAction value: lClick ! !

BorderedMorph subclass: #LOGame
	instanceVariableNames: 'cells'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PBE-LightsOut'!

!LOGame methodsFor: 'as yet unclassified' stamp: 'alexz 9/19/2012 19:02'!
cellsPerSide
	"El nmero de celdas a lo largo de cada lado del juego"
	^ 10! !

!LOGame methodsFor: 'as yet unclassified' stamp: 'alexz 9/19/2012 18:10'!
initialize
	| sampleCell width height n |
	super initialize.
	n := self cellsPerSide.
	sampleCell := LOCell new.
	width := sampleCell width.
	height := sampleCell height.
	self bounds: (5@5 extent: ((width*n) @(height*n)) + (2*self borderWidth)).
	cells := Matrix new: n tabulate: [ :i :j | self newCellAt: i at: j ].! !

!LOGame methodsFor: 'as yet unclassified' stamp: 'alexz 9/20/2012 09:19'!
mouseMove: anEvent	! !

!LOGame methodsFor: 'as yet unclassified' stamp: 'DDC 9/21/2012 21:28'!
newCellAt: i at: j
	"Creacin de una celda para la posicin (i, j) y la aade en pantalla en la posicin adecuada. Retorna 	la nueva celda "
	| c origin |
	c := LOCell new.
	origin := self innerBounds origin.
	self addMorph: c.
	c position: ((i - 1)*c width) @ ((j - 1)*c height) + origin.
	c mouseAction: [ :lClick| lClick ifTrue: [self toggleNeighboursOfCellAt: i at: j] 
		ifFalse: [self toggleDiagonalNeighboursOfCellAt: i  at:j ]].
	^c

! !

!LOGame methodsFor: 'game logic' stamp: 'DDC 9/21/2012 21:27'!
toggleDiagonalNeighboursOfCellAt: i at: j
   ((i > 1) & (j > 1)) ifTrue: [ (cells at: i - 1 at: j - 1) toggleState].
   ((i < self cellsPerSide) & (j < self cellsPerSide)) ifTrue: [ (cells at: i + 1 at: j + 1) toggleState].
   ((i < self cellsPerSide) & (j > 1)) ifTrue: [ (cells at: i + 1  at: j - 1) toggleState].
   ((i > 1) & (j < self cellsPerSide)) ifTrue: [ (cells at: i - 1 at: j + 1) toggleState].! !

!LOGame methodsFor: 'game logic' stamp: 'alexz 9/20/2012 06:05'!
toggleNeighboursOfCellAt: i at: j
   (i > 1) ifTrue: [ (cells at: i - 1 at: j ) toggleState].
   (i < self cellsPerSide) ifTrue: [ (cells at: i + 1 at: j) toggleState].
   (j > 1) ifTrue: [ (cells at: i  at: j - 1) toggleState].
   (j < self cellsPerSide) ifTrue: [ (cells at: i at: j + 1) toggleState].! !
